"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracleDb = void 0;
const Logger_1 = require("../Logger");
const autobind_decorator_1 = require("autobind-decorator");
class OracleDb {
    constructor({ oracledb }) {
        this.oracledb = oracledb;
    }
    getDriver() {
        return this.oracledb;
    }
    async getOrCreatePool({ user, password, connectString }) {
        try {
            return this.oracledb.getPool();
        }
        catch (e) {
            if (e.message.includes('NJS-047')) {
                return await this.oracledb.createPool({
                    connectString,
                    user,
                    password,
                    poolIncrement: 1,
                    poolMax: 3,
                    poolMin: 0,
                });
            }
            else {
                Logger_1.logger.error(e.message);
            }
        }
    }
    async closePool() {
        try {
            await this.oracledb.getPool().close();
        }
        catch (e) {
            Logger_1.logger.error(e.message);
        }
    }
}
__decorate([
    autobind_decorator_1.boundMethod
], OracleDb.prototype, "getDriver", null);
__decorate([
    autobind_decorator_1.boundMethod
], OracleDb.prototype, "getOrCreatePool", null);
__decorate([
    autobind_decorator_1.boundMethod
], OracleDb.prototype, "closePool", null);
exports.OracleDb = OracleDb;
